`include "umsg.sv"
//`include "test_cfg.sv"

class udriver_inst extends uvm_driver #(utran_inst);

  `uvm_component_utils(udriver_inst)
  
  virtual instructionIF.driver si;
  
  //test_cfg  cfg_class;
  
  bit [15:0]	inst;
  bit [15:0]	cmem[*];
  bit			assembly;
  
  function new (string name, uvm_component parent);
    super.new(name, parent);
  endfunction: new
  
  function void build_phase(uvm_phase phase);
    super.build_phase(phase);
  endfunction: build_phase
  
  task run_phase(uvm_phase phase);
    //uvm_resource_db #(test_cfg)::read_by_name("test","config",cfg_class,this);
    //assembly = cfg_class.assembly;
	if(!assembly) begin
	  utran_inst m_inst;
	  forever 
	  begin
		@(posedge si.clk);
		begin
		  seq_item_port.get(m_inst);
		  case(m_inst.inst)
		    lit: inst = { m_inst.opc1,m_inst.UnsgVal};
			default: inst = { m_inst.opc1,m_inst.opc2,m_inst.opc3};
		  endcase
		  si.instr = inst;
		end
	  end
	end
	
	if(assembly) begin
	  cmem_init();
	  @(posedge tb.i_rst_n.reset);
	  forever
	  begin
	    @(posedge si.clk);
	    //si.inst = read_cmem(si.pc_r[15:1]);
	  end
	end
	  
  endtask : run_phase

  function automatic bit[15:0] read_cmem(bit[15:0] addr);
    bit [15:0] data;
    data = cmem[addr];
	$display("%t: cmem=%h",$time,data);
    return data;
  endfunction
  
  task automatic cmem_init();
    bit[2048:0] hexfile;
	bit[7:0] mem[*];
	int i;
    tb.get_program_file_name(hexfile,"hexmain");
    $readmemh(hexfile, mem);
	for(i=0; i<(1<<USEQ_ADDR_BITS); i+=2) begin
	  cmem[i/2] = {mem[i+1],mem[i]};
	end
  endtask
  
endclass: udriver_inst