`include "umsg.sv"

class umonitor_inst extends uvm_monitor #(utran_inst);

 `uvm_component_utils(umonitor_inst)
 
  uvm_analysis_port #(utran_inst) ap;
  
  virtual instructionIF.monitor mi;
  
  bit [15:0]	inst;
 
  function new (string name, uvm_component parent);
	super.new(name, parent);
  endfunction: new

  function void build_phase(uvm_phase phase);
   super.build_phase(phase);
   ap = new("inst_group_cov_ap", this);
  endfunction: build_phase
  
  task run_phase(uvm_phase phase);
	utran_inst m_inst;
	m_inst = new();
    forever
    begin
      @(posedge mi.clk)
	  inst = mi.instr;
      ap.write(m_inst);
	  #1;
	end
  endtask : run_phase
  
endclass : umonitor_inst







