`include "usequence_inst.sv"
`include "udriver_inst.sv"
`include "umonitor_inst.sv"
`include "inst_cov_collector.sv"

typedef uvm_sequencer #(utran_inst) usequencer_inst;

class uagent_inst extends uvm_agent;
  `uvm_component_utils(uagent_inst)
  
  virtual instructionIF inst_if;
  
  //uvm_analysis_port#(utran_apb) ap;

  usequencer_inst	m_sequencer_inst; 
  udriver_inst		m_driver_inst;
  umonitor_inst 	m_monitor_inst;
  inst_cov_collector m_inst_cov_collector;
  
  function new(string name, uvm_component parent);
    super.new(name, parent);
  endfunction: new
  
  function void build_phase(uvm_phase phase);
    super.build_phase(phase);
	
	//tran_ap = new(.name("tran_ap"), .parent(this));
    m_driver_inst		=	udriver_inst	::type_id::create ("m_driver_inst",    this);
    m_sequencer_inst	=	usequencer_inst	::type_id::create ("m_sequencer_inst", this);
	m_monitor_inst		=	umonitor_inst	::type_id::create ("m_monitor_inst", this);
	m_inst_cov_collector = inst_cov_collector ::type_id::create("m_inst_cov_collector", this);
  endfunction: build_phase
  
  function void connect_phase(uvm_phase phase);
    m_driver_inst.seq_item_port.connect(m_sequencer_inst.seq_item_export);
	m_monitor_inst.ap.connect(m_inst_cov_collector.analysis_export);
	assert(uvm_config_db #(virtual instructionIF)::get(this, "*", "instructionIF", inst_if))
	  begin
	    m_monitor_inst.mi = inst_if;
		//if (get_is_active() == UVM_ACTIVE)
	    m_driver_inst.si = inst_if;
	  end
   endfunction: connect_phase
   
endclass: uagent_inst
