`include "usequence_ram.sv" 
`include "udriver_ram.sv"

typedef uvm_sequencer #(utran_ram) usequencer_ram;

class uagent_ram extends uvm_agent;
  `uvm_component_utils(uagent_ram)
  
  virtual ramIF ram_if;
  
  //uvm_analysis_port#(utran_ram) ap;

  usequencer_ram	m_sequencer_ram;
  udriver_ram 		m_driver_ram;

  function new(string name, uvm_component parent);
    super.new(name, parent);
  endfunction: new
  
  function void build_phase(uvm_phase phase);
    super.build_phase(phase);
	
	//tran_ap = new(.name("tran_ap"), .parent(this));
    m_sequencer_ram		=	usequencer_ram	::type_id::create ("m_sequencer_ram", this);
	m_driver_ram		=	udriver_ram	::type_id::create ("m_driver_ram", this);
  endfunction: build_phase
  
  function void connect_phase(uvm_phase phase);
    m_driver_ram.seq_item_port.connect(m_sequencer_ram.seq_item_export); // Connect driver and sequencer
	assert(uvm_config_db #(virtual ramIF)::get(this, "*", "ramIF", ram_if)) // Get interface from database
	  begin
	    m_driver_ram.mi = ram_if; // Provide interface to driver
	  end
   endfunction: connect_phase
   
endclass: uagent_ram
