`ifndef MSG_SV_CLASS
 `define MSG_SV_CLASS

typedef enum {
			Type_I,
			Type_II,
			Type_III,
			Type_IV,
			Type_V,
			Type_VI,
			Type_VII,
			Type_VIII,
			Type_IX
			} instruction_type;
 
typedef enum {
			ori4_inst	,
			add2_inst	,
			sub2_inst	,
			lw_inst		,
			lb_inst		,
			sw_inst		,
			sb_inst		,
			and_inst	,
			or_inst		,
			xor_inst	,
			xnor_inst	,
			sra_inst	,
			srl_inst	,
			sll_inst	,
			sext_inst	,			
			add2c_inst	,
			sub2c_inst	,
			andr1_inst	,
			orr1_inst	,
			xorr1_inst	,
			xnorr1_inst	,
			srai_inst	,
			srli_inst	,
			slli_inst	,
			brpc_inst	,
			br_inst		,			
			add3_inst	,
			sub3_inst	,
			mtsr_inst	,
			mfsr_inst	,
			ret_inst	,			
			halt_inst	,			
			ldir1_inst	,
		  
              instnum
              } instgroup;

typedef enum bit[3:0]{
			ori4_op1 =0	,
			add2_op1	,
			sub2_op1	,
			lw_op1		,
			lb_op1		,
			sw_op1		,
			sb_op1		,
			alu_op1		,
			alur1_op1	,
			brpc_op1	,
			br_op1		,
			empty_op1	,
			add3_op1	,
			sub3_op1	,
			cmd_op1		,
			ldir1_op1
			} opcode1;
			
typedef enum bit[3:0]{
			and_op3	=0	,
			or_op3		,
			xor_op3		,
			xnor_op3	,
			sra_op3		,
			srl_op3		,
			sll_op3		,
			sext_op3	,
			add2c_op3	,
			sub2c_op3
			} opcode3;

typedef enum bit[3:0]{
			andr1_op3 =0,
			orr1_op3	,
			xorr1_op3	,
			xnorr1_op3	,
			empty_op3	,
			srai_op3	,
			srli_op3	,
			slli_op3
			} opcode3r;				
			
typedef enum bit[3:0]{
				mtsr_op4 =0	,
				mfsr_op4	,
				ret_op4		,
				halt_op4
				} opcode4;
		
typedef enum bit[3:0]{
				eq		= 0	,
				neq			,
				lt			,
				le			,
				gt			,
				ge			,
				ltu			,
				leu			,
				gtu			,
				geu			,
				c			,
				o			,
				al 		= 14,
				alal 	= 15
				} condition;

typedef enum bit[3:0]{Rd_1 = 1,Rd_2,Rd_3,Rd_4,Rd_5,Rd_6,Rd_7,Rd_8,Rd_9,Rd_10,Rd_11,Rd_12,Rd_13,Rd_14} RegD;
typedef enum bit[3:0]{Rd_br_1 = 1,Rd_br_2,Rd_br_3,Rd_br_4,Rd_br_5,Rd_br_6,Rd_br_7,Rd_br_8,Rd_br_9,Rd_br_10,Rd_br_11,Rd_br_12,Rd_br_13,Rd_br_14} RegD_br;
typedef enum bit[3:0]{Rs1_1 = 1,Rs1_2,Rs1_3,Rs1_4,Rs1_5,Rs1_6,Rs1_7,Rs1_8,Rs1_9,Rs1_10,Rs1_11,Rs1_12,Rs1_13,Rs1_14} RegS1;
typedef enum bit[3:0]{Rs2_1 = 1,Rs2_2,Rs2_3,Rs2_4,Rs2_5,Rs2_6,Rs2_7,Rs2_8,Rs2_9,Rs2_10,Rs2_11,Rs2_12,Rs2_13,Rs2_14} RegS2;
				
class inst_group_prob;

  int        prob[instnum-1:0];
  
  function new();

  endfunction
endclass

`endif

