// UVM Basic test

`include "uenv.sv"
//`include "test_cfg.sv"

class uvm_basic extends uvm_test;
   
  `uvm_component_utils(uvm_basic)
  uenv e;
  //test_cfg cfg_class;
  usequence_inst seq;
  usequence_inst_init seqi;
  usequence_ram seqr;
  
  int assembly = 0;
  int coverage;
  
   function new (string name, uvm_component parent);
      super.new(name,parent);
      //cfg_class = new(); // Create custom config class
   endfunction : new
   
   function void build_phase(uvm_phase phase);
      super.build_phase(phase);
      e = uenv ::type_id::create("e", this); // Build environment
   endfunction : build_phase
   
   task run_phase(uvm_phase phase);
     
	 //cfg_class.assembly = 0;
	 //uvm_resource_db#(test_cfg)::write_by_name("test","config",cfg_class,this);
	 	
	    seqi = usequence_inst_init::type_id::create();
		seq = usequence_inst::type_id::create();
		seqr = usequence_ram::type_id::create();
	 
     this.set_report_verbosity_level_hier(UVM_DEBUG);

      // Signalize start of test
      phase.raise_objection(this);
      `uvm_info("UVM_BASIC","Run uvm_basic",UVM_MEDIUM)
	  
      // Initialize environment
      e.initialize();
	  
	  if(!assembly) 
	  begin
	  
	    // Start init sequence 
	    seqi.start(e.m_agent_inst.m_sequencer_inst);
 
        fork
		  // Start random sequence
	      seq.start(e.m_agent_inst.m_sequencer_inst);
		  // Start ram sequence
	      seqr.start(e.m_agent_ram.m_sequencer_ram);
		join_any
	  end
	  while(coverage<100)
      begin
        #10us;
        coverage=$get_coverage();
      end    
      #100
	  
      // Drop objection to finish test	
      phase.drop_objection(this);
   endtask: run_phase
   
   //Executes after run_phase, have to be always present in test to give 
   //information to runtest.pl that test is finished
   function void extract_phase(uvm_phase phase);
      tb.uvm_g_sig_done();
   endfunction : extract_phase
   
endclass: uvm_basic
